rule_files:
  - "kyverno.yaml"
evaluation_interval: "1m"
tests:
  - interval: "1m"
    input_series: []
    alert_rule_test:
      - alertname: "Toolforge Kyverno unknown state"
        eval_time: "5m"
        exp_alerts:
          - exp_labels:
              severity: "warning"
              team: "wmcs"
            exp_annotations:
              summary: "Toolforge Kyverno has unknown state. Kyverno might be down"
              description: "Prometheus was unable to fetch data from Toolforge Kyverno. It might be down, resulting in new user workloads being unable to run."
              dashboard: "https://grafana-rw.wmcloud.org/d/kyverno/kyverno?orgId=1&var-DS_PROMETHEUS_KYVERNO=prometheus-tools"
              runbook: "https://wikitech.wikimedia.org/wiki/Portal:Toolforge/Admin/Runbooks/Toolforge_Kyverno_unknown_state"

  - interval: "1m"
    input_series:
      - series: "kyverno_policy_rule_info_total{rule_type='validate', status_ready='true', policy_validation_mode='enforce', pod_name='kyverno-admission-controller-xyz'}"
        values: "1x5"
      - series: "kyverno_policy_rule_info_total{rule_type='validate', status_ready='true', policy_validation_mode='enforce', pod_name='kyverno-admission-controller-xyz'}"
        values: "1x5"
      - series: "kyverno_policy_rule_info_total{rule_type='validate', status_ready='true', policy_validation_mode='enforce', pod_name='kyverno-admission-controller-xyz'}"
        values: "1x5"
    alert_rule_test:
      - alertname: "Toolforge Kyverno low policy resources"
        eval_time: "5m"
        exp_alerts:
          - exp_labels:
              severity: "warning"
              team: "wmcs"
            exp_annotations:
              summary: "Toolforge Kyverno has low amount of policy resources"
              description: "Toolforge Kyverno has an unexpectedly low number (<3000) of validating policy resources loaded, in ENFORCE mode, and READY status. We usually expect higher number of policy resources. It might result in new user workloads being unable to run."
              dashboard: "https://grafana-rw.wmcloud.org/d/kyverno/kyverno?orgId=1&var-DS_PROMETHEUS_KYVERNO=prometheus-tools"
              runbook: "https://wikitech.wikimedia.org/wiki/Portal:Toolforge/Admin/Runbooks/Toolforge_Kyverno_low_policy_resources"

  - interval: "1m"
    input_series: []
    alert_rule_test:
      - alertname: "Toolforge Kyverno no policy resources"
        eval_time: "5m"
        exp_alerts:
          - exp_labels:
              severity: "warning"
              team: "wmcs"
            exp_annotations:
              summary: "Toolforge Kyverno has no policy resources"
              description: "Toolforge Kyverno has no validating policy resources loaded. This is unexpected. It might result in new user workloads being unable to run."
              dashboard: "https://grafana-rw.wmcloud.org/d/kyverno/kyverno?orgId=1&var-DS_PROMETHEUS_KYVERNO=prometheus-tools"
              runbook: "https://wikitech.wikimedia.org/wiki/Portal:Toolforge/Admin/Runbooks/Toolforge_Kyverno_no_policy_resources"
